.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
LOOP_COUNT = 100000

.data
MyQword dq 12345678901234567890

.data?
AscBuf dd 10 dup(?)
AscBuf2 dd 10 dup(?)

.code
start:
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
mov edx, dword ptr MyQword[4]
mov eax, dword ptr MyQword[0]
call Asc64
; print offset AscBuf, 9 ; use for testing with LOOP_COUNT = 1
counter_end
print str$(eax), 9, "cycles for Asc64", 13, 10

counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
push offset AscBuf2
push dword ptr MyQword[4]
push dword ptr MyQword[0]
call U64ToStr
; print offset AscBuf2, 9
print str$(eax), 9, "cycles for U64ToStr", 13, 10

inkey chr$(13, 10, "--- ok ---", 13)
exit

Asc64 proc
;Convert 64-bit unsigned integer to ASCII decimal string
;Call With: EDX:EAX= QWORD value to display
;
; Returns: EDI= Offset into AscBuf of first numchar

std
mov edi,offset AscBuf+18
mov ecx,edx
xchg eax,esi
mov ebx,100

Asc64a: xor edx,edx
xchg eax,ecx
div ebx
xchg eax,ecx
xchg eax,esi
div ebx
xchg eax,esi
xchg eax,edx
aam
xchg al,ah
or ax,3030h
stosw
mov eax,ecx
or eax,esi
jnz Asc64a

inc edi
inc edi
cmp byte ptr [edi],30h ;leading 0 ?
cld
jz Asc64b ;yes - supress it

ret ;no - done

Asc64b: inc edi
ret

Asc64 endp

U64ToStr proc QwVal:QWORD, pszString:DWORD
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
push ebp
push esi
push edi
push ebx
mov esi,[esp+1*4][4*4]; a0
mov edi,[esp+2*4][4*4]; a1
mov ebp,[esp+3*4][4*4]; buffer pointer
test edi,edi
jz @F
;; QWORD conversion loop
@@U64Cvt:
mov eax,0CCCCCCCDh; = b0
mul esi; get a0*b0 = d1:d0
mov ecx,edx;d1
mov eax,0CCCCCCCDh; = b0
xor ebx,ebx
mul edi; get a1*b0 = e1:e0
add ecx,eax;e0
adc ebx,edx;e1
mov eax,0CCCCCCCCh; =b1
mul esi; get a0*b1 = f1:f0
add ecx,eax;f0
adc ebx,edx;f1
mov ecx,0
mov eax,0CCCCCCCCh; =b1
adc ecx,ecx
mul edi; get a1*b1 = g1:g0
add eax,ebx;g0
adc edx,ecx;g1
shrd eax,edx,3
shr edx,3;;------ quotient in edx::eax
; upper dwords will be the same after multiplication
lea ecx,[eax*4+eax]
mov ebx,esi
lea ecx,[ecx+ecx-'0']
sub ebx,ecx
mov esi,eax
mov [ebp],bl
mov edi,edx
add ebp,1
test edi,edi
jnz @@U64Cvt
@@:
;; we are here if HI-DWORD is 0
mov eax,esi
mov ebx,esi
mov edi,0CCCCCCCDh
;; Lower Dword conversion loop
@@U32Cvt:
mul edi
shr edx,3
lea ecx,[edx*4+edx]
lea ecx,[ecx+ecx-'0']
sub ebx,ecx
mov eax,edx
mov [ebp],bl
mov ebx,edx
add ebp,1
test eax,eax
jnz @@U32Cvt
;; Calculate output string length and reverse it
mov edi,[esp+3*4][4*4]
mov [ebp],al
mov eax,ebp
sub eax,edi
;; reverse buffer digits
@@: sub ebp,1
mov bl,[edi]
mov cl,[ebp]
mov [ebp],bl
mov [edi],cl
add edi,1
cmp edi,ebp
jb @B
;; string length in eax
pop ebx
pop edi
pop esi
pop ebp
ret 3*4
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
U64ToStr endp

end start